"""
LIGO Scientific Collaboration Algorithm Library - minimal Python package

LALSuite is the LIGO Scientific Collaboration Algorithm Library for
gravitational-wave analysis. Its primary purpose is searching for and
characterizing astrophysical signals in gravitational-wave time series data,
particularly data from ground-based detectors such as `LIGO
<https://www.ligo.org>`_ and `Virgo <http://www.virgo-gw.eu>`_.

LALSuite consists of a set of ``configure``-``make``-``install`` style software
packages organized by problem domain or source classification. This Python
package provides a standalone, dependency-free binary distribution of the
libraries and Python modules in LALSuite for Linux and macOS.

To install, simply run::

    $ pip install lalsuite
"""

import os
import re
from string import Template
import shutil
import tempfile

from setuptools import Extension, find_packages, setup
from setuptools.command.build_ext import build_ext as _build_ext
from distutils.command.build_scripts import build_scripts as _build_scripts

# Recursive globbing like in Python 3.5
from glob2 import glob

# These variables come from automake.
subst = dict(prefix=os.path.abspath('build/inst'))
subst['exec_prefix'] = Template('@exec_prefix@').substitute(**subst)
BINDIR = Template('@bindir@').substitute(**subst)
LIBEXECDIR = Template('@libexecdir@').substitute(**subst)
PYTHONDIR = Template('@pythondir@').substitute(**subst)
BASE_VERSION = '@BASE_VERSION@'
NIGHTLY_VERSION = '@NIGHTLY_VERSION@'

if NIGHTLY_VERSION:
    VERSION = BASE_VERSION + '.' + NIGHTLY_VERSION
else:
    VERSION = BASE_VERSION


class build_ext(_build_ext):
    """Override setuptools build_ext: just copy pre-built modules."""

    def build_extension(self, ext):
        src = os.path.join(PYTHONDIR, ext.name.replace('.', '/') + '.so')
        dst = self.get_ext_fullpath(ext.name)
        self.copy_file(src, dst)


stub = '''\
#!python
import os, pkg_resources, sys
os.execv(pkg_resources.resource_filename('lalapps', 'bin/{}'), sys.argv)
'''


class build_scripts(_build_scripts):
    """Override setuptools install_scripts: strip the .py extensions and
    add the shebang lines."""

    def run(self):
        old_scripts = self.scripts[:]
        new_scripts = []
        self.mkpath(self.build_dir)
        tmpdir = tempfile.mkdtemp(dir=self.build_dir)
        try:
            for old_script in old_scripts:
                basename = os.path.basename(old_script)
                base, ext = os.path.splitext(basename)
                if not old_script.startswith(LIBEXECDIR):
                    new_script = os.path.join(tmpdir, basename)
                    with open(new_script, 'w') as outfile:
                        outfile.write(stub.format(os.path.basename(old_script)))
                elif ext == '.py':
                    new_script = os.path.join(tmpdir, base)
                    with open(new_script, 'wb') as outfile:
                        outfile.write(b'#!python\n')
                        with open(old_script, 'rb') as infile:
                            shutil.copyfileobj(infile, outfile)
                else:
                    new_script = old_script
                new_scripts.append(new_script)
            self.scripts = new_scripts
            _build_scripts.run(self)
            self.scripts = old_scripts
        finally:
            shutil.rmtree(tmpdir)


setup(
    name='lalsuite',
    license='GPL-2+',
    version=VERSION,
    description=__doc__.strip().split('\n')[0],
    long_description='\n'.join(__doc__.strip().split('\n')[1:]).strip(),
    url='https://git.ligo.org/lscsoft/lalsuite',
    author='LIGO Scientific Collaboration',
    author_email='lal-discuss@ligo.org',
    maintainer='Adam Mercer',
    maintainer_email='adam.mercer@ligo.org',
    classifiers=[
        'Intended Audience :: Science/Research',
        'License :: OSI Approved :: GNU General Public License v2 or later (GPLv2+)',
        'Operating System :: POSIX',
        'Programming Language :: Python :: 2',
        'Programming Language :: Python :: 2.7',
        'Programming Language :: Python :: 3',
        'Programming Language :: Python :: 3.4',
        'Programming Language :: Python :: 3.5',
        'Programming Language :: Python :: 3.6',
        'Topic :: Scientific/Engineering :: Astronomy',
        'Topic :: Scientific/Engineering :: Physics'],
    cmdclass={'build_ext': build_ext, 'build_scripts': build_scripts},
    package_dir={'': PYTHONDIR, 'lalapps.bin': BINDIR},
    package_data={'lalapps.bin': ['*']},
    packages=find_packages(PYTHONDIR) + ['lalapps.bin'],
    scripts=glob(LIBEXECDIR + '/**/*.py') + glob(BINDIR + '/*'),
    ext_modules=[Extension(os.path.relpath(filename, PYTHONDIR)
                           .replace('.so', '')
                           .replace('/', '.'), [])
                 for filename in glob(PYTHONDIR + '/**/*.so')],
    install_requires=['ligo-segments', 'numpy>=1.7', 'python-dateutil']
)
